      subroutine readgrid(filegrid,k,itime,numxgrid,
     +numygrid,numzgrid,nspec,nspec2,
     +nageclass,wetgrid,drygrid,grid,lage,scaledepo,scaleconc,
     +decayconstant)

      include 'include_file'

      real grid(nxmax,nymax,nzmax,maxspec,maxageclass)
      real wetgrid(nxmax,nymax,maxspec,maxageclass)
      real drygrid(nxmax,nymax,maxspec,maxageclass)
      integer lage(0:maxageclass)

***************** new sparse output
      integer fact,ii,ir
      real sparse_dump_r(nxmax*nymax*nzmax)
      integer sparse_dump_i(nxmax*nymax*nzmax)
      integer sp_count_i,sp_count_r
***************** new sparse output


      character*250 filegrid


      open(10,file=filegrid,form='unformatted',status='old')
      read(10,end=99) itime 
      write(*,*) itime

C Loop about all age classes
****************************

      do 38 nage=1,nageclass

C Initialize age class fields
*****************************

        do 63 ix=1,numxgrid
          do 63 jy=1,numygrid
            wetgrid(ix,jy,k,nage)=0.
            drygrid(ix,jy,k,nage)=0.
            do 63 kz=1,numzgrid
63            grid(ix,jy,kz,k,nage)=0.


C Read wet deposition
*********************

        fact=1
        read(10) sp_count_i
        read(10) (sparse_dump_i(ix),ix=1,sp_count_i)
        read(10) sp_count_r
        read(10) (sparse_dump_r(ix),ix=1,sp_count_r)

        ii=0
        do 32 ir=1,sp_count_r
          if ((sparse_dump_r(ir)*fact).gt.smallnum) then
             ii=ii+1
             n=sparse_dump_i(ii)
             fact=fact*(-1.)
          else
             pos=pos+1
          endif

          jy=n/numxgrid
          ix=n-numxgrid*jy
          wetgrid(ix+1,jy+1,k,nage)=sparse_dump_r(ir)

32      continue

C Read dry deposition
*********************

        fact=1
        read(10) sp_count_i
        read(10) (sparse_dump_i(ix),ix=1,sp_count_i)
        read(10) sp_count_r
        read(10) (sparse_dump_r(ix),ix=1,sp_count_r)

        ii=0
        do 36 ir=1,sp_count_r
          if ((sparse_dump_r(ir)*fact).gt.smallnum) then
             ii=ii+1
             n=sparse_dump_i(ii)
             fact=fact*(-1.)
          else
             pos=pos+1
          endif

          jy=n/numxgrid
          ix=n-numxgrid*jy
          drygrid(ix+1,jy+1,k,nage)=sparse_dump_r(ir)

36      continue


C Read concentrations
*********************

        fact=1
        read(10) sp_count_i
        read(10) (sparse_dump_i(ix),ix=1,sp_count_i)
        read(10) sp_count_r
        read(10) (sparse_dump_r(ix),ix=1,sp_count_r)
c       write(*,*) sp_count_i,sp_count_r
c       write(*,*) (sparse_dump_i(ix),ix=1,sp_count_i)
c       write(*,*) (sparse_dump_r(ix),ix=1,sp_count_r)

        ii=0
        do 47 ir=1,sp_count_r
          if ((sparse_dump_r(ir)*fact).gt.smallnum) then
             ii=ii+1
             n=sparse_dump_i(ii)
             fact=fact*(-1.)
          else
             n=n+1
          endif

          kz=n/(numxgrid*numygrid)
          jy=(n-kz*numxgrid*numygrid)/numxgrid
          ix=n-numxgrid*numygrid*kz-numxgrid*jy
          grid(ix+1,jy+1,kz,k,nage)=abs(sparse_dump_r(ir))

47      continue


C Scale values as defined by user
*********************************

          do 41 ix=1,numxgrid
            do 41 jy=1,numygrid
              drygrid(ix,jy,k,nage)=drygrid(ix,jy,k,nage)*scaledepo
              wetgrid(ix,jy,k,nage)=wetgrid(ix,jy,k,nage)*scaledepo
              do 41 kz=1,numzgrid
                grid(ix,jy,kz,k,nage)=grid(ix,jy,kz,k,nage)*
     +          exp(-1.*float(lage(nage)+lage(nage-1))/2./
     +          decayconstant)
                grid(ix,jy,kz,k,nage)=grid(ix,jy,kz,k,nage)*scaleconc
41              continue


C End species loop, end age class loop
**************************************

138       continue
38      continue

      close(10)

99    continue


      end
